%define bmodule squashfs
%define module %{bmodule}-lzma
%define name dkms-%{module}
%define version 3.3
%define extraver -457-2
%define kver 2.6.24
%define release %mkrel 10

Summary: Squashfs compressed read-only filesystem (using LZMA)
Name: %{name}
Version: %{version}
Release: %{release}
Source0: %{bmodule}%{version}.tgz
Source1: http://www.squashfs-lzma.org/dl/sqlzma%{version}%{extraver}.tar.bz2
Patch0: squashfs3.3-2618.patch
# http://sourceforge.net/tracker/index.php?func=detail&aid=1912192&group_id=63835&atid=505341
Patch1: squashfs3.3-2625.patch
# http://sourceforge.net/mailarchive/forum.php?thread_name=Pine.LNX.4.64.0805291610580.3218%40vixen.sonytel.be&forum_name=squashfs-devel
Patch2: squashfs3.3-f_pos.patch
# http://squashfs.cvs.sourceforge.net/squashfs/squashfs/kernel/fs/squashfs/inode.c?r1=1.61&r2=1.61.4.1&view=patch&sortby=date&pathrev=devel-3_4
Patch3: squashfs3.3-2627.patch
# http://kerneltrap.org/index.php?q=mailarchive/linux-kernel/2008/11/17/4175304/thread
Patch4: squashfs-d_alloc_anon-removal.patch
License: GPL
Group: System/Kernel and hardware
BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-buildroot
Url: http://squashfs.sourceforge.net/
BuildArch: noarch
Requires(post): dkms
Requires(preun): dkms
Requires(post): dkms-lzma

%description
Squashfs is a compressed read-only filesystem.
This module is build with support for the LZMA compression algorithm.

%package -n %{module}-kernel
Summary:	Virtual package requiring squashfs-lzma modules
Group:		System/Kernel and hardware
Requires:	kmod(squashfs-lzma)
Requires:	kmod(unlzma)

%description -n %{module}-kernel
This virtual package requires the squashfs-lzma modules and their
dependencies.

%prep
%setup -q -n %{bmodule}%{version} -a 1
mkdir -p dkms
pushd dkms
patch -t < ../kernel-patches/linux-%{kver}/%{bmodule}%{version}-patch || [ -f %{bmodule}.h ]
patch -t < ../sqlzma2k-%{version}.patch
perl -pi -e 's,^#include <linux/(%{bmodule}.*\.h)>$,#include "$1",' *.{c,h}
popd
%patch0 -p1 -b .2618
%patch1 -p1 -b .2625
%patch2 -p1 -b .f_pos
%patch3 -p1 -b .2627
%patch4 -p1 -b .d_anon

cp sqmagic.h dkms/

cat > dkms/build.sh <<EOF
cp -a /usr/src/lzma-*/ lzma
cd lzma
make -C "\$1" M=\`pwd\`
cd ..
cp lzma/sqlzma.h lzma/Module.symvers .
make -C "\$1" M=\`pwd\`
EOF
chmod +x dkms/build.sh

cat > dkms/dkms.conf <<EOF
PACKAGE_NAME=%{name}
PACKAGE_VERSION=%{version}-%{release}
MAKE[0]="./build.sh \$kernel_source_dir"
DEST_MODULE_LOCATION[0]="/kernel/fs/%{bmodule}"
DEST_MODULE_NAME[0]="%{module}"
BUILT_MODULE_NAME[0]="%{bmodule}"
AUTOINSTALL=yes
EOF

%build

%install
rm -rf %{buildroot}
mkdir -p %{buildroot}/usr/src/%{module}-%{version}-%{release}/
tar c -C dkms . | tar x -C %{buildroot}/usr/src/%{module}-%{version}-%{release}/

%clean
rm -rf %{buildroot}

%post
set -x
/usr/sbin/dkms --rpm_safe_upgrade add -m %{module} -v %{version}-%{release}
/usr/sbin/dkms --rpm_safe_upgrade build -m %{module} -v %{version}-%{release}
/usr/sbin/dkms --rpm_safe_upgrade install -m %{module} -v %{version}-%{release}
:

%preun
set -x
/usr/sbin/dkms --rpm_safe_upgrade remove -m %{module} -v %{version}-%{release} --all
:

%files
%defattr(-,root,root)
/usr/src/%{module}-%{version}-%{release}

%files -n %{module}-kernel


%changelog
* Mon Mar 30 2009 Pascal Terjan <pterjan@mandriva.org> 3.3-10mdv2009.1
+ Revision: 362453
- Enable the hack again, binary dkms generation process does not work with deendencies currently

* Tue Mar 17 2009 Pascal Terjan <pterjan@mandriva.org> 3.3-9mdv2009.1
+ Revision: 356777
- Don't build dkms-lzma, its Module.symvers is now saved

* Fri Feb 27 2009 Olivier Blin <oblin@mandriva.com> 3.3-8mdv2009.1
+ Revision: 345626
- take lzma sources from /usr/src instead of /var/lib/dkms (iurt skips dkms prep commands)

* Wed Feb 25 2009 Pascal Terjan <pterjan@mandriva.org> 3.3-7mdv2009.1
+ Revision: 344952
- Handle dependeny over dkms-lzma

* Fri Feb 06 2009 Christophe Fergeau <cfergeau@mandriva.org> 3.3-6mdv2009.1
+ Revision: 338102
- Add new patch to adjust to kernel API changes

* Tue Sep 02 2008 Olivier Blin <oblin@mandriva.com> 3.3-5mdv2009.0
+ Revision: 279044
- fix build with 2.6.27

* Thu Jul 10 2008 Olivier Blin <oblin@mandriva.com> 3.3-4mdv2009.0
+ Revision: 233413
- add virtual squashfs-lzma-kernel package requiring squashfs-lzma
  modules and their deps (to be used in auto_inst or rpmsrate)

* Mon Jul 07 2008 Olivier Blin <oblin@mandriva.com> 3.3-3mdv2009.0
+ Revision: 232611
- fix performance issue with large directories, from upstream cvs
- update sqlzma snapshot

* Mon Jul 07 2008 Olivier Blin <oblin@mandriva.com> 3.3-2mdv2009.0
+ Revision: 232492
- fix build with 2.6.25 (probably breaks 2.6.18 support)
- add back support for kernels <= 2.6.23 (mostly for Xen 2.6.18 kernel)
- use 2.6.24 version of the patch

  + Thierry Vignaud <tvignaud@mandriva.com>
    - fix no-buildroot-tag

* Wed Nov 14 2007 Olivier Blin <oblin@mandriva.com> 3.3-1mdv2008.1
+ Revision: 108821
- add lzma support
- copy dkms-squashfs-lzma from dkms-squashfs

* Wed Nov 14 2007 Olivier Blin <oblin@mandriva.com> 3.3-2mdv2008.1
+ Revision: 108710
- allow to build with 2.6.18 (for Xen kernel, and probably all kernels < 2.6.23)
- initial dkms-squashfs package
- create dkms-squashfs

